#ifndef LINIJA_H
#define LINIJA_H

#include "Tacka.h"
#include <vector>
using namespace std;

// Klase koje imaju pokazivacka polja moramo da ucinimo bezbednima za koriscenje
// Takve klase moraju da imaju eksplicitno definisan kopirajuci i premestajuci konstruktor, kao i destruktor
class Linija {
public:
	Linija(int kap);

	// Kopirajuci konstruktor
	Linija(const Linija& druga);

	// Premestajuci konstruktor
	Linija(Linija&& druga);

	// Destruktor
	~Linija();

	void dodajTacku(const Tacka& t);
	void pisi() const;

private:
	// Dinamicki niz
	Tacka* niz_;
	int kap_, pop_;
};

#endif // !LINIJA_H

