#ifndef LINIJA_H
#define LINIJA_H

#include "Tacka.h"
#include <vector>
using namespace std;

// Sve klase imaju ugradjenu mogucnost inicijalizacije kopijom
// Postoje dve varijante takve inicijalizacije: kopirajuca inicijalizacija i premestajuca inicijalizacija
// Obe inicijalizacije podrazumevano kopiraju sva polja nekog objekta (plitka kopija - shallow copy) i kreiraju nov objekat sa kopiranim poljima

// Kopirajuca inicijalizacija se poziva kada objekat koji se koristi kao prototip postoji u memoriji i nastavlja da zivi i nakon toga
// npr. Klasa obj1;
//		Klasa obj2(obj1); -- kopirajuca inicijalizacija

// Premestajuca inicijalizacija se poziva kada objekat koji se koristi kao prototip uskoro nestaje zbog zavrsetka svog zivotnog veka
// npr. Klasa f() { return Klasa(); }
//		...
//		Klasa obj = f(); -- Funkcija 'f' vraca nov objekat koji postoji do kraja izraza a zatim nestaje
class Linija {
public:
	Linija(int kap);

	// Destruktor
	~Linija();

	void dodajTacku(const Tacka& t);
	void pisi() const;

private:
	// Dinamicki niz
	Tacka* niz_;
	int kap_, pop_;
};

#endif // !LINIJA_H

