#ifndef LINIJA_H
#define LINIJA_H

#include "Tacka.h"
#include <vector>
using namespace std;

class Linija {
public:

	// Definisanjem novog konstruktora, brise se podrazumevani konstruktor
	// Ukoliko nam je potreban, mozemo ga restaurirati sledecom linijom koda
	Linija() = default;

	// Kopirajuci konstruktor
	Linija(const Linija& druga);

	// Premestajuci konstruktor
	Linija(Linija&& druga);

	// Destruktor
	~Linija();

	void dodajTacku(const Tacka& t);
	void pisi() const;

private:
	// Posto objekti klase Tacka ne mogu da se kopiraju, nije ih moguce cuvati po vrednosti u vektoru 'niz_'
	// Objekte klase Tacka cuvamo preko pokazivaca na njih
	// Posto vektor ima pokazivacka polja, potrebno je obezbediti klasu dodavanjem kopirajuceg i premestajuceg konstruktora, kao i destruktora
	vector<Tacka*> niz_;
};

#endif // !LINIJA_H

