#include <iostream>
using namespace std;

class A {
	int* a;
public:
	A() { a = new int; cout << "A kreiran" << endl; }
	virtual ~A() { delete a; cout << "A unisten" << endl; }
	// ~A() { delete a; cout << "A unisten" << endl; } // Ovako ne bi moglo!

	// Metoda clone pravi nov objekat klase A kojeg inicijalizuje kopirajucim konstruktorom kome prosledjuje tekuci objekat
	virtual A* clone() const { return new A(*this); }

	virtual void write() const { cout << "A ispisan" << endl; }
};

class B : public A {
	int* b;
public:
	B() { b = new int; cout << "B kreiran" << endl; }
	~B() { delete b; cout << "B unisten" << endl; }

	B* clone() const override { return new B(*this); }

	void write() const override { cout << "B ispisan" << endl; }
};

class C : public B {
	int* c;
public:
	C() { c = new int; cout << "C kreiran" << endl; }
	~C() { delete c; cout << "C unisten" << endl; }

	C* clone() const override { return new C(*this); }

	void write() const override { cout << "C ispisan" << endl; }
};

int main() {
	A * ptrA = new B;
	// Pozivamo destruktor objekta na kojeg pokazuje pokazivac 'ptrA'. Ukoliko nije virtuelan, pozvace se destruktor klase A jer je pokazivac tipa klase A.
	// Na taj nacin ostace deo objekta B da curi u memoriji (int* b) jer se nikad nije pozvao destruktor klase B
	// Ako je destruktor ~A() virtuelan tada se poziva destruktor klase POKAZIVANOG OBJEKTA!
	// Na taj nacin ce se pozvati destruktor ~B() koji ce unistiti i int* b i svoj nasledjeni podobjekat koji se unistava destruktorom klase A pa ce i int* a biti unisteno.
	delete ptrA;

	cout << endl;

	// Virtualnost destruktora se nasledjuje pa ce i delete ptrB na ispravan nacin da unisti objekat iako nismo eksplicitno rekli da je ~B() virtuelan.
	B* ptrB = new C;
	delete ptrB;

	cout << endl;

	// Cas 9.
	// Konstruktor ne moze da bude virtuelan pa nam je potreban nacin da kopiramo objekte na polimorfan nacin
	// Jedini nacin je da pozivamo polimorfnu metodu kopiraj() koja ce u svakoj klasi biti implementirana tako da poziva tacan kopirajuci konstruktor
	A* ptrA1 = new B; cout << endl;
	A* ptrA2 = new C; cout << endl;
	A* ptrA1cpy = ptrA1->clone();
	ptrA1cpy->write();
	A* ptrA2cpy = ptrA2->clone();
	ptrA2cpy->write();

	return 0;
}